"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

require("./component.scss");

var _seReactDropdown = _interopRequireDefault(require("se-react-dropdown"));

var _loadsh = require("loadsh");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var SearchIcon = function SearchIcon(props) {
  return _react["default"].createElement("svg", props, _react["default"].createElement("path", {
    fill: "currentColor",
    d: "M505 442.7L405.3 343c-4.5-4.5-10.6-7-17-7H372c27.6-35.3 44-79.7 44-128C416 93.1 322.9 0 208 0S0 93.1 0 208s93.1 208 208 208c48.3 0 92.7-16.4 128-44v16.3c0 6.4 2.5 12.5 7 17l99.7 99.7c9.4 9.4 24.6 9.4 33.9 0l28.3-28.3c9.4-9.4 9.4-24.6.1-34zM208 336c-70.7 0-128-57.2-128-128 0-70.7 57.2-128 128-128 70.7 0 128 57.2 128 128 0 70.7-57.2 128-128 128z"
  }));
};

SearchIcon.defaultProps = {
  "'data-prefix'": "fas",
  "'data-icon'": "search",
  className: "svg-inline--fa fa-search fa-w-16",
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 512 512"
};

var SyncIcon = function SyncIcon(props) {
  return _react["default"].createElement("svg", props, _react["default"].createElement("path", {
    fill: "currentColor",
    d: "M370.72 133.28C339.458 104.008 298.888 87.962 255.848 88c-77.458.068-144.328 53.178-162.791 126.85-1.344 5.363-6.122 9.15-11.651 9.15H24.103c-7.498 0-13.194-6.807-11.807-14.176C33.933 94.924 134.813 8 256 8c66.448 0 126.791 26.136 171.315 68.685L463.03 40.97C478.149 25.851 504 36.559 504 57.941V192c0 13.255-10.745 24-24 24H345.941c-21.382 0-32.09-25.851-16.971-40.971l41.75-41.749zM32 296h134.059c21.382 0 32.09 25.851 16.971 40.971l-41.75 41.75c31.262 29.273 71.835 45.319 114.876 45.28 77.418-.07 144.315-53.144 162.787-126.849 1.344-5.363 6.122-9.15 11.651-9.15h57.304c7.498 0 13.194 6.807 11.807 14.176C478.067 417.076 377.187 504 256 504c-66.448 0-126.791-26.136-171.315-68.685L48.97 471.03C33.851 486.149 8 475.441 8 454.059V320c0-13.255 10.745-24 24-24z"
  }));
};

SyncIcon.defaultProps = {
  "'data-prefix'": "fas",
  "'data-icon'": "sync-alt",
  className: "svg-inline--fa fa-sync-alt fa-w-16",
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 512 512"
};

var TimesIcon = function TimesIcon(props) {
  return _react["default"].createElement("svg", props, _react["default"].createElement("path", {
    fill: "currentColor",
    d: "M242.72 256l100.07-100.07c12.28-12.28 12.28-32.19 0-44.48l-22.24-22.24c-12.28-12.28-32.19-12.28-44.48 0L176 189.28 75.93 89.21c-12.28-12.28-32.19-12.28-44.48 0L9.21 111.45c-12.28 12.28-12.28 32.19 0 44.48L109.28 256 9.21 356.07c-12.28 12.28-12.28 32.19 0 44.48l22.24 22.24c12.28 12.28 32.2 12.28 44.48 0L176 322.72l100.07 100.07c12.28 12.28 32.2 12.28 44.48 0l22.24-22.24c12.28-12.28 12.28-32.19 0-44.48L242.72 256z"
  }));
};

TimesIcon.defaultProps = {
  "'data-prefix'": "fas",
  "'data-icon'": "times",
  className: "svg-inline--fa fa-times fa-w-11",
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 352 512"
};

var Component =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Component, _React$Component);

  function Component(props, context) {
    var _this;

    _classCallCheck(this, Component);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Component).call(this, props, context));
    var selectedList = (props.selectedList || []).map(function (p) {
      return _objectSpread({}, p);
    });
    _this.state = {
      selectedList: selectedList || [],
      //user selected value from dropdown + user input value
      selectedItem: null,
      value: '' //the value of input box

    };
    _this.myRef = _react["default"].createRef();
    return _this;
  }

  _createClass(Component, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if ((0, _loadsh.get)(this, 'props.selectedList', []).length > 0) {
        this.fireChange();
      }
    }
  }, {
    key: "append",
    value: function append(e) {
      var _this2 = this;

      var selectedItem = this.getSelectedItem();
      var json = {
        text: selectedItem.text,
        key: selectedItem.value,
        value: e.target.value
      };
      var onEnter = this.props.onEnter;
      var item = this.state.selectedList.find(function (p) {
        return p.key == selectedItem.value; //&& p.value == e.target.value
      });

      var callback = function callback() {
        _this2.setState({
          value: ''
        });

        onEnter && onEnter(_this2.state.selectedList);

        _this2.fireChange();
      };

      if (!item) {
        this.setState(function (state) {
          var selectedList = state.selectedList.concat(json);
          return {
            selectedList: selectedList
          };
        }, callback);
      } else {
        this.setState(function (prevState) {
          var selectedList = prevState.selectedList.map(function (p) {
            if (p.key == json.key) {
              return json;
            } else {
              return p;
            }
          });
          return {
            selectedList: selectedList
          };
        }, callback);
      }
    }
  }, {
    key: "removeSelected",
    value: function removeSelected(item) {
      var _this3 = this;

      var onRemove = this.props.onRemove;
      this.setState(function (state) {
        var selectedList = state.selectedList.filter(function (p) {
          return p.text != item.text || p.value != item.value;
        });
        return {
          selectedList: selectedList
        };
      }, function () {
        var selectedList = _this3.state.selectedList;
        onRemove && onRemove(selectedList);

        _this3.fireChange();
      });
    }
  }, {
    key: "clean",
    value: function clean() {
      this.setState({
        selectedList: []
      }, this.fireChange.bind(this));
    }
  }, {
    key: "fireChange",
    value: function fireChange() {
      var onChange = this.props.onChange;
      onChange && onChange(this.state.selectedList);
    }
  }, {
    key: "_handleKeyDown",
    value: function _handleKeyDown(e) {
      if (e.key == 'Enter') {
        this.append(e);

        if (this.props.stopEventSpread) {
          e.preventDefault();
          e.stopPropagation();
          return false;
        }
      }
    }
  }, {
    key: "updateValue",
    value: function updateValue(e) {
      this.setState({
        value: e.target.value
      });
    }
  }, {
    key: "getSelectedItem",
    value: function getSelectedItem() {
      var data = this.props.data;
      return this.state.selectedItem || (data.length ? data[0] : {});
    }
  }, {
    key: "updateSelectedItem",
    value: function updateSelectedItem(selectedItem) {
      this.setState({
        selectedItem: selectedItem
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      var _this$props = this.props,
          data = _this$props.data,
          useFontAwesome = _this$props.useFontAwesome,
          placeholder = _this$props.placeholder;
      var selectedList = this.state.selectedList;
      var CleverSearchIcon = useFontAwesome ? function () {
        return _react["default"].createElement("i", {
          className: "fal fa-search search-icon"
        });
      } : function () {
        return _react["default"].createElement(SearchIcon, {
          className: "search-icon"
        });
      };
      var CleverSyncIcon = useFontAwesome ? function () {
        return _react["default"].createElement("i", {
          className: "fal fa-trash-alt sync-icon"
        });
      } : function () {
        return _react["default"].createElement(SyncIcon, {
          className: "sync-icon"
        });
      };
      var CleverTimesIcon = useFontAwesome ? function (props) {
        return _react["default"].createElement("i", _extends({
          className: "fal fa-times"
        }, props));
      } : function (props) {
        return _react["default"].createElement(TimesIcon, props);
      };
      return _react["default"].createElement("div", {
        ref: this.myRef,
        className: 'sec-react-label-value ' + (this.props.className || '')
      }, _react["default"].createElement("div", {
        className: "element-wrapper"
      }, _react["default"].createElement(_seReactDropdown["default"], {
        data: data,
        onChange: this.updateSelectedItem.bind(this)
      }), _react["default"].createElement("div", {
        className: "input-wrapper"
      }, _react["default"].createElement(CleverSearchIcon, null), _react["default"].createElement("span", {
        className: "label"
      }, this.getSelectedItem().text || '', ":"), _react["default"].createElement("input", {
        className: "box",
        type: "text",
        value: this.state.value,
        onChange: this.updateValue.bind(this),
        onKeyDown: this._handleKeyDown.bind(this),
        placeholder: placeholder || "press enter to add"
      })), _react["default"].createElement("span", {
        className: "data-clear",
        onClick: this.clean.bind(this)
      }, _react["default"].createElement(CleverSyncIcon, {
        className: "sync-icon"
      }))), _react["default"].createElement("ul", {
        className: "selected-wrapper" + (selectedList.length <= 0 ? ' hidden' : '')
      }, selectedList.map(function (item) {
        return _react["default"].createElement("li", {
          key: "".concat(item.text, "-").concat(item.value)
        }, _react["default"].createElement("span", null, item.text + ': ' + item.value), _react["default"].createElement(CleverTimesIcon, {
          onClick: _this4.removeSelected.bind(_this4, item)
        }));
      })));
    }
  }]);

  return Component;
}(_react["default"].Component);

var _default = Component;
exports["default"] = _default;
Component.propTypes = {
  data: _propTypes["default"].arrayOf(_propTypes["default"].exact({
    value: _propTypes["default"].string,
    text: _propTypes["default"].string
  })),
  placeholder: _propTypes["default"].string,
  onEnter: _propTypes["default"].func,
  onRemove: _propTypes["default"].func,
  onChange: _propTypes["default"].func
};